'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var getBoundingClientRect = function getBoundingClientRect(element) {
  var rect = element.getBoundingClientRect();
  return {
    left: Math.ceil(rect.left),
    width: Math.ceil(rect.width)
  };
};

var ReactRanger = function (_React$Component) {
  _inherits(ReactRanger, _React$Component);

  function ReactRanger() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, ReactRanger);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ReactRanger.__proto__ || Object.getPrototypeOf(ReactRanger)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      activeHandleIndex: null
    }, _this.handleEls = [], _this.handleDimensions = [], _this.onPress = function (e, activeHandleIndex) {
      _this.setState({
        activeHandleIndex: activeHandleIndex
      });
      document.addEventListener('mousemove', _this.onDrag);
      document.addEventListener('touchmove', _this.onDrag);
      document.addEventListener('mouseup', _this.onRelease);
      document.addEventListener('touchend', _this.onRelease);
      if (_this.props.onPress) {
        _this.props.onPress(e);
      }
    }, _this.onDrag = function (e) {
      var _this$props = _this.props,
          onChange = _this$props.onChange,
          onDrag = _this$props.onDrag;
      var activeHandleIndex = _this.state.activeHandleIndex;

      var values = _this.getValues();

      var newValue = _this.getValueForClientX(e.clientX);
      var newRoundedValue = _this.roundToStep(newValue);

      var newValues = [].concat(_toConsumableArray(values.slice(0, activeHandleIndex)), [newRoundedValue], _toConsumableArray(values.slice(activeHandleIndex + 1)));

      // This is some code that attempts to allow the handles
      // to reorder themselves based on the sorted values. It's buggy.
      // but worth keeping around.
      //
      // let newActiveHandleIndex = activeHandleIndex
      //
      // if (typeof this.lastValue !== "undefined" && this.lastValue !== newValue) {
      //   const prevVal = values[activeHandleIndex - 1]
      //     ? values[activeHandleIndex - 1]
      //     : min
      //   const nextVal = values[activeHandleIndex + 1]
      //     ? values[activeHandleIndex + 1]
      //     : max

      //   console.log(this.lastValue, newValue)

      //   if (newValue < this.lastValue && newValue <= prevVal) {
      //     newActiveHandleIndex = Math.max(activeHandleIndex - 1, 0)
      //   } else if (newValue > this.lastValue && newValue >= nextVal) {
      //     newActiveHandleIndex = Math.min(
      //       activeHandleIndex + 1,
      //       values.length - 1
      //     )
      //   }
      // }

      // this.lastValue = newValue

      if (onDrag) {
        onDrag(e);
      }
      onChange(newValues);
    }, _this.onRelease = function (e) {
      document.removeEventListener('mousemove', _this.onDrag);
      document.removeEventListener('touchmove', _this.onDrag);
      document.removeEventListener('mouseup', _this.onRelease);
      document.removeEventListener('touchend', _this.onRelease);
      _this.setState({
        activeHandleIndex: null
      }, function () {
        if (_this.props.onRelease) {
          _this.props.onRelease(e);
        }
      });
    }, _this.roundToStep = function (val) {
      var _this$props2 = _this.props,
          min = _this$props2.min,
          max = _this$props2.max,
          steps = _this$props2.steps,
          stepSize = _this$props2.stepSize;


      var left = min;
      var right = max;
      if (steps) {
        steps.forEach(function (step) {
          if (step <= val && step > left) {
            left = step;
          }
          if (step >= val && step < right) {
            right = step;
          }
        });
      } else {
        if (typeof stepSize === 'undefined') {
          throw new Error('Warning: Failed prop type: The prop `stepSize` is expected in `ReactRanger`, but its value is `undefined`');
        }
        while (left < val && left + stepSize < val) {
          left += stepSize;
        }

        right = Math.min(left + stepSize, max);
      }

      if (val - left < right - val) {
        return left;
      }
      return right;
    }, _this.getValues = function () {
      return Array.isArray(_this.props.value) ? _this.props.value : [_this.props.value];
    }, _this.getPercentageForValue = function (val) {
      var _this$props3 = _this.props,
          min = _this$props3.min,
          max = _this$props3.max;

      return Math.max(0, Math.min(100, (val - min) / (max - min) * 100));
    }, _this.getValueForClientX = function (clientX) {
      var _this$props4 = _this.props,
          min = _this$props4.min,
          max = _this$props4.max;

      var trackDims = getBoundingClientRect(_this.trackEl);
      var percentageValue = (clientX - trackDims.left) / trackDims.width;
      var value = (max - min) * percentageValue;
      return value + min;
    }, _this.getTicks = function () {
      var _this$props5 = _this.props,
          min = _this$props5.min,
          max = _this$props5.max,
          tickSize = _this$props5.tickSize,
          controlledTicks = _this$props5.ticks,
          controlledSteps = _this$props5.steps;
      // Build the ticks

      var ticks = controlledTicks;
      if (!ticks) {
        if (controlledSteps) {
          ticks = controlledSteps;
        } else {
          ticks = [min];
          while (ticks[ticks.length - 1] < max - tickSize) {
            ticks.push(ticks[ticks.length - 1] + tickSize);
          }
          ticks.push(max);
        }
      }
      return ticks.map(function (value, i) {
        return {
          value: value,
          getTickProps: function getTickProps() {
            var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
                key = _ref2.key,
                _ref2$style = _ref2.style,
                style = _ref2$style === undefined ? {} : _ref2$style;

            return {
              key: typeof key !== 'undefined' ? key : i,
              style: _extends({}, style, {
                position: 'absolute',
                left: _this.getPercentageForValue(value) + '%'
              })
            };
          }
        };
      });
    }, _this.getSegments = function () {
      var _this$props6 = _this.props,
          min = _this$props6.min,
          max = _this$props6.max;

      var values = _this.getValues();
      var sortedValues = [].concat(_toConsumableArray(values)).sort(function (a, b) {
        return a - b;
      });

      return [].concat(_toConsumableArray(sortedValues), [max]).map(function (value, i) {
        return {
          value: value,
          getSegmentProps: function getSegmentProps() {
            var _ref3 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
                key = _ref3.key,
                _ref3$style = _ref3.style,
                style = _ref3$style === undefined ? {} : _ref3$style;

            var left = _this.getPercentageForValue(sortedValues[i - 1] ? sortedValues[i - 1] : min);
            var width = _this.getPercentageForValue(value) - left;
            return {
              key: typeof key !== 'undefined' ? key : i,
              style: _extends({}, style, {
                position: 'absolute',
                left: left + '%',
                width: width + '%'
              })
            };
          }
        };
      });
    }, _this.getHandles = function () {
      var activeHandleIndex = _this.state.activeHandleIndex;

      var values = _this.getValues();

      return values.map(function (value, i) {
        return {
          value: value,
          active: i === activeHandleIndex,
          getHandleProps: function getHandleProps() {
            var _extends2;

            var _ref4 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

            var key = _ref4.key,
                _ref4$refProp = _ref4.refProp,
                refProp = _ref4$refProp === undefined ? 'ref' : _ref4$refProp,
                _ref4$innerRef = _ref4.innerRef,
                innerRef = _ref4$innerRef === undefined ? function () {} : _ref4$innerRef,
                _ref4$onMouseDown = _ref4.onMouseDown,
                _onMouseDown = _ref4$onMouseDown === undefined ? function () {} : _ref4$onMouseDown,
                _ref4$onTouchStart = _ref4.onTouchStart,
                _onTouchStart = _ref4$onTouchStart === undefined ? function () {} : _ref4$onTouchStart,
                _ref4$style = _ref4.style,
                style = _ref4$style === undefined ? {} : _ref4$style,
                rest = _objectWithoutProperties(_ref4, ['key', 'refProp', 'innerRef', 'onMouseDown', 'onTouchStart', 'style']);

            return _extends((_extends2 = {
              key: typeof key !== 'undefined' ? key : i
            }, _defineProperty(_extends2, refProp, function (el) {
              _this.handleEls[i] = el;
              innerRef(el);
            }), _defineProperty(_extends2, 'onMouseDown', function onMouseDown(e) {
              e.persist();
              _this.onPress(e, i);
              _onMouseDown(e);
            }), _defineProperty(_extends2, 'onTouchStart', function onTouchStart(e) {
              e.persist();
              _this.onPress(e, i);
              _onTouchStart(e);
            }), _defineProperty(_extends2, 'tabIndex', 1), _defineProperty(_extends2, 'style', _extends({}, style, {
              outline: 0,
              position: 'absolute',
              top: '50%',
              left: _this.getPercentageForValue(value) + '%',
              transform: 'translate(-50%, -50%)',
              zIndex: i === activeHandleIndex ? '1' : '0'
            })), _extends2), rest);
          }
        };
      });
    }, _this.getTrackProps = function () {
      var _ref6;

      var _ref5 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          _ref5$style = _ref5.style,
          style = _ref5$style === undefined ? {} : _ref5$style,
          _ref5$refProp = _ref5.refProp,
          refProp = _ref5$refProp === undefined ? 'ref' : _ref5$refProp;

      var onTrackClick = _this.props.onTrackClick;
      var activeHandleIndex = _this.state.activeHandleIndex;

      return _ref6 = {}, _defineProperty(_ref6, refProp, function (el) {
        _this.trackEl = el;
      }), _defineProperty(_ref6, 'onClick', function onClick(e) {
        e.persist();
        if (activeHandleIndex !== null || !onTrackClick || _this.handleEls.find(function (d) {
          return d.contains(e.target);
        })) {
          return;
        }
        var value = _this.getValueForClientX(e.clientX);
        onTrackClick(_this.roundToStep(value), value);
      }), _defineProperty(_ref6, 'style', _extends({}, style, {
        position: 'relative',
        userSelect: 'none'
      })), _ref6;
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(ReactRanger, [{
    key: 'render',
    value: function render() {
      var children = this.props.children;
      var activeHandleIndex = this.state.activeHandleIndex;
      var getTrackProps = this.getTrackProps;

      var ticks = this.getTicks();
      var segments = this.getSegments();
      var handles = this.getHandles();

      return children({
        getTrackProps: getTrackProps,
        ticks: ticks,
        segments: segments,
        handles: handles,
        activeHandleIndex: activeHandleIndex
      });
    }
  }]);

  return ReactRanger;
}(_react2.default.Component);

ReactRanger.propTypes = {
  children: _propTypes2.default.func.isRequired,
  min: _propTypes2.default.number.isRequired,
  max: _propTypes2.default.number.isRequired,
  value: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.arrayOf(_propTypes2.default.number)]).isRequired,
  stepSize: _propTypes2.default.number,
  tickSize: _propTypes2.default.number,
  steps: _propTypes2.default.arrayOf(_propTypes2.default.number),
  ticks: _propTypes2.default.arrayOf(_propTypes2.default.number),
  onChange: _propTypes2.default.func,
  onTrackClick: _propTypes2.default.func,
  onPress: _propTypes2.default.func,
  onDrag: _propTypes2.default.func,
  onRelease: _propTypes2.default.func
};
ReactRanger.defaultProps = {
  tickSize: 10
};
exports.default = ReactRanger;